Scriptname idek:sig:InfoGunQuestScript extends Quest Conditional

Actor Property PlayerRef						Auto Const Mandatory
Ammo Property SIG_InfoGunAmmo					Auto Const Mandatory
Message Property SIG_CaravanInfoMessage			Auto Const Mandatory
Message Property SIG_SettlerInfoMessage			Auto Const Mandatory
Keyword Property WorkshopLinkCaravanStart		Auto Const Mandatory
Keyword Property WorkshopLinkCaravanEnd			Auto Const Mandatory
ActorValue Property WorkshopRatingProvisioner	Auto Const Mandatory
ReferenceAlias Property Victim					Auto Const Mandatory
LocationAlias Property CaravanStartLoc			Auto Const Mandatory
LocationAlias Property CaravanEndLoc			Auto Const Mandatory

int magSize = 12 const

Function GunEquipped(bool b)
	if (b)
		RefillAmmo()
		RegisterForAnimationEvent(PlayerRef, "WeaponFire")
		sigTrace("Registered for WeaponFire event!")
	else
		UnregisterForAnimationEvent(PlayerRef, "WeaponFire")
		sigTrace("Unregistered for WeaponFire event!")
	endif
EndFunction

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	if (akSource == PlayerRef && asEventName == "WeaponFire")
		RefillAmmo()
	endif
EndEvent

Function RefillAmmo()
	PlayerRef.AddItem(SIG_InfoGunAmmo, magSize-PlayerRef.GetItemCount(SIG_InfoGunAmmo), true)
	; sigTrace("Ammo refilled!")
EndFunction

Function ShowInfo(Actor akTarget)
	Victim.ForceRefTo(akTarget)
	if (akTarget is WorkshopNPCScript)
		; Debug.MessageBox("Actor is a settler!")
		if (akTarget.GetValue(WorkshopRatingProvisioner) > 0)
			Location s = akTarget.GetLinkedRef(WorkshopLinkCaravanStart).GetCurrentLocation()
			Location e = akTarget.GetLinkedRef(WorkshopLinkCaravanEnd).GetCurrentLocation()
			if (!s || !e)
				return
			endif
			CaravanStartLoc.ForceLocationTo(s)
			CaravanEndLoc.ForceLocationTo(e)
			SIG_CaravanInfoMessage.Show()
		else
			SIG_SettlerInfoMessage.Show()
		endif
	else
		; Debug.MessageBox("Actor is not a settler!")
	endif
EndFunction

Function sigTrace(string s)
	Debug.Trace(s)
EndFunction
